#### Programmer par Romain Joly - Institut Fourier ####

import math
import random
from tkinter import *

# fenetre avec image de fond
fenetre = Tk()
fenetre.title("Les cercles de Rubik")

photo = PhotoImage(file="fond-Rubik.gif")
Canevas = Canvas(fenetre,width = 648, height =385)
Canevas.create_image(0,0,anchor=NW, image=photo)
Canevas.pack()

Listegraph = []

# point
def Cercle(x,y,c):
    global Listegraph
    r = 10
    item=Canevas.create_oval(x-r, y-r, x+r, y+r, outline=c, fill=c)
    Listegraph.append(item)

d=162*math.cos(math.pi/5)

# fonction affichage des points
def P(j,n):
    if j==1:
        if n<5:
            x=193+147*math.cos(2*n*math.pi/5)
            y=193-147*math.sin(2*n*math.pi/5)
        if n>4:
            k=9-n
            x=455-2*d*math.cos(2*k*math.pi/5)+147*math.cos(2*k*math.pi/5)
            y=193-2*d*math.sin(2*k*math.pi/5)+147*math.sin(2*k*math.pi/5)
        Cercle(x,y,'blue')
    if j==2:
        for i in [-1,1]:
            if n<5:
                x=193+147*math.cos(2*n*math.pi/5+i*0.1)
                y=193-147*math.sin(2*n*math.pi/5+i*0.1)
            if n>4:
                k=9-n
                x=455-2*d*math.cos(2*k*math.pi/5)+147*math.cos(2*k*math.pi/5+i*0.1)
                y=193-2*d*math.sin(2*k*math.pi/5)+147*math.sin(2*k*math.pi/5+i*0.1)
            Cercle(x,y,'blue')
    if j==3:
        for i in [-1,0,1]:
            if n<5:
                x=193+147*math.cos(2*n*math.pi/5+i*0.2)
                y=193-147*math.sin(2*n*math.pi/5+i*0.2)
            if n>4:
                k=9-n
                x=455-2*d*math.cos(2*k*math.pi/5)+147*math.cos(2*k*math.pi/5+i*0.2)
                y=193-2*d*math.sin(2*k*math.pi/5)+147*math.sin(2*k*math.pi/5+i*0.2)
            Cercle(x,y,'blue')
    if j==4:
        for i in [-3,-1,1,3]:
            if n<5:
                x=193+147*math.cos(2*n*math.pi/5+i*0.1)
                y=193-147*math.sin(2*n*math.pi/5+i*0.1)
            if n>4:
                k=9-n
                x=455-2*d*math.cos(2*k*math.pi/5)+147*math.cos(2*k*math.pi/5+i*0.1)
                y=193-2*d*math.sin(2*k*math.pi/5)+147*math.sin(2*k*math.pi/5+i*0.1)
            Cercle(x,y,'blue')
    if j==8:
        if n>4:
            k=9-n
            x=455-147*math.cos(2*k*math.pi/5)
            y=193-147*math.sin(2*k*math.pi/5)
        if n<5:
            x=193+2*d*math.cos(2*n*math.pi/5)-147*math.cos(2*n*math.pi/5)
            y=193-2*d*math.sin(2*n*math.pi/5)+147*math.sin(2*n*math.pi/5)
        Cercle(x,y,'#000aaa000')
    if j==7:
        for i in [-1,1]:
            if n>4:
                k=9-n
                x=455-147*math.cos(2*k*math.pi/5+i*0.1)
                y=193-147*math.sin(2*k*math.pi/5+i*0.1)
            if n<5:
                x=193+2*d*math.cos(2*n*math.pi/5)-147*math.cos(2*n*math.pi/5+i*0.1)
                y=193-2*d*math.sin(2*n*math.pi/5)+147*math.sin(2*n*math.pi/5+i*0.1)
            Cercle(x,y,'#000aaa000')
    if j==6:
        for i in [-2,0,2]:
            if n>4:
                k=9-n
                x=455-147*math.cos(2*k*math.pi/5+i*0.1)
                y=193-147*math.sin(2*k*math.pi/5+i*0.1)
            if n<5:
                x=193+2*d*math.cos(2*n*math.pi/5)-147*math.cos(2*n*math.pi/5+i*0.1)
                y=193-2*d*math.sin(2*n*math.pi/5)+147*math.sin(2*n*math.pi/5+i*0.1)
            Cercle(x,y,'#000aaa000')
    if j==5:
        for i in [-3,-1,1,3]:
            if n>4:
                k=9-n
                x=455-147*math.cos(2*k*math.pi/5+i*0.1)
                y=193-147*math.sin(2*k*math.pi/5+i*0.1)
            if n<5:
                x=193+2*d*math.cos(2*n*math.pi/5)-147*math.cos(2*n*math.pi/5+i*0.1)
                y=193-2*d*math.sin(2*n*math.pi/5)+147*math.sin(2*n*math.pi/5+i*0.1)
            Cercle(x,y,'#000aaa000')


# Mise en place des cercles exterieurs
Cercle(248,27,'blue')
Cercle(62,77,'blue')
Cercle(42,105,'blue')
Cercle(52,295,'blue')
Cercle(34,266,'blue')
Cercle(74,322,'blue')
Cercle(196,368,'blue')
Cercle(230,364,'blue')
Cercle(263,353,'blue')
Cercle(294,336,'blue')

Cercle(400,27,'#000aaa000')
Cercle(585,77,'#000aaa000')
Cercle(606,105,'#000aaa000')
Cercle(596,295,'#000aaa000')
Cercle(615,266,'#000aaa000')
Cercle(574,322,'#000aaa000')
Cercle(452,368,'#000aaa000')
Cercle(419,364,'#000aaa000')
Cercle(385,353,'#000aaa000')
Cercle(354,336,'#000aaa000')

points = [1,2,3,4,5,6,7,8,9]
for i in points:
    P(i,i)

# Commandes pour tourner
def gaucheplus():
    global points
    global Listegraph
    for i in range(20):
        item = Listegraph[-1]
        Canevas.delete(item)
        del Listegraph[-1]
    point2 = []
    point2=point2+[points[8]]
    point2=point2+[points[0]]
    point2=point2+[points[1]]
    point2=point2+[points[2]]
    for i in range(4,8):
        point2=point2+[points[i]]
    point2=point2+[points[3]]
    points=point2
    for i in range(0,9):
        P(points[i],i+1)

def gauchemoins():
    global points
    global Listegraph
    for i in range(20):
        item = Listegraph[-1]
        Canevas.delete(item)
        del Listegraph[-1]
    point2 = []
    point2=point2+[points[1]]
    point2=point2+[points[2]]
    point2=point2+[points[3]]
    point2=point2+[points[8]]
    for i in range(4,8):
        point2=point2+[points[i]]
    point2=point2+[points[0]]
    points=point2
    for i in range(0,9):
        P(points[i],i+1)

def droiteplus():
    global points
    global Listegraph
    for i in range(20):
        item = Listegraph[-1]
        Canevas.delete(item)
        del Listegraph[-1]
    point2 = []
    for i in range(0,4):
        point2=point2+[points[i]]    
    point2=point2+[points[5]]
    point2=point2+[points[6]]
    point2=point2+[points[7]]
    point2=point2+[points[8]]
    point2=point2+[points[4]]
    points=point2
    for i in range(0,9):
        P(points[i],i+1)

def droitemoins():
    global points
    global Listegraph
    for i in range(20):
        item = Listegraph[-1]
        Canevas.delete(item)
        del Listegraph[-1]
    point2 = []
    for i in range(0,4):
        point2=point2+[points[i]]    
    point2=point2+[points[8]]
    point2=point2+[points[4]]
    point2=point2+[points[5]]
    point2=point2+[points[6]]
    point2=point2+[points[7]]
    points=point2
    for i in range(0,9):
        P(points[i],i+1)

# Commande d'initialisation
def Init():
    global points
    for i in range(20):
        item = Listegraph[-1]
        Canevas.delete(item)
        del Listegraph[-1]
    points = [1,2,3,4,5,6,7,8,9]
    for i in points:
        P(i,i)

# Melange
def Melange():
    for i in range(100):
        mouv=random.randint(1,4)
        if mouv==1:
            gaucheplus()
        if mouv==2:
            gauchemoins()
        if mouv==3:
            droiteplus()
        if mouv==4:
            droitemoins()    

framegauche = Frame(fenetre, borderwidth=1, relief="solid")
framegauche.pack(side=LEFT,padx=10, pady=3)
framedroite = Frame(fenetre, borderwidth=1, relief="solid")
framedroite.pack(side=LEFT,padx=10, pady=3)

# Creation de widgets Buttons pour tourner
Boutong = Button(framegauche, text ='G+ \u21b6',font=("Arial",25), command = gaucheplus)
Boutong.pack(side=TOP,padx=5, pady=5)
Boutongg = Button(framegauche, text ='G- \u21b7',font=("Arial",25), command = gauchemoins)
Boutongg.pack(side=BOTTOM,padx=5, pady=5)
Boutond = Button(framedroite, text ='\u21b7 D+',font=("Arial",25), command = droiteplus)
Boutond.pack(side=TOP,padx=5, pady=5)
Boutondd = Button(framedroite, text ='\u21b6 D-',font=("Arial",25), command = droitemoins)
Boutondd.pack(side=BOTTOM,padx=5, pady=5)

# Creation d'un widget Button (bouton Quitter)
BoutonQuitter = Button(fenetre, text ='Quitter', font=("Arial",15),command = fenetre.destroy)
BoutonQuitter.pack(side=RIGHT,padx=11, pady=11)

# Creation d'un widget Button pour melanger
Boutonmel = Button(fenetre, text ='M\xe9langer',font=("Arial",15), command = Melange)
Boutonmel.pack(side=RIGHT,padx=11, pady=11)

# Creation d'un widget Button pour reinitialiser
Boutonmel = Button(fenetre, text ='R\xe9initialiser',font=("Arial",15), command = Init)
Boutonmel.pack(side=RIGHT,padx=11, pady=11)


fenetre.mainloop()
